#pragma semicolon 1
#include <sourcemod>
#include <vip_core>

public Plugin:myinfo = 
{
	name = "[VIP] Features Manager",
	author = "R1KO",
	version = "2.0 DEV"
};

new Handle:g_hFeaturesArray,
	Handle:g_hFeaturesTrie,
	Handle:g_hFeatures[MAXPLAYERS+1];

new g_iRounds;

new bool:g_bIsCSGO;
new bool:g_bMapEnable;
/*
#include "fm/cfg_loader.sp"
*/
public OnPluginStart()
{
	g_hFeaturesArray = CreateArray(ByteCountToCells(64));
	g_hFeaturesTrie = CreateTrie();

	g_bIsCSGO = bool:(GetEngineVersion() == Engine_CSGO);
	
	
	HookEvent("round_end",	Event_RoundEnd, EventHookMode_PostNoCopy);

	if(g_bIsCSGO)
	{
		HookEvent("announce_phase_end", Event_Restart, EventHookMode_PostNoCopy);
		HookEvent("cs_match_end_restart", Event_Restart, EventHookMode_PostNoCopy);
		HookEvent("round_prestart", Event_RoundStart, EventHookMode_PostNoCopy);
	}
	else
	{
		HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	}

	HookConVarChange(FindConVar("mp_restartgame"), OnRestartCvar);
/*
	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
	*/
}

public OnRestartCvar(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	g_iRounds = 0;
}

/*
native VIPFM_ToggleFeatures(iClient, bool:bStatus, Handle:hFeaturesArray);
native VIPFM_ToggleFeature(iClient, bool:bStatus, const String:szFeature[]);
*/

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
//	CreateNative("VIPFM_ToggleAllFeatures", Native_ToggleAllFeatures);
	CreateNative("VIPFM_ToggleFeatures", Native_ToggleFeatures);
	CreateNative("VIPFM_ToggleFeature", Native_ToggleFeature);

	return APLRes_Success;
}
/*
public Native_ToggleAllFeatures(Handle:hPlugin, iNumParams)
{
	new iClient = GetNativeCell(1);
	if(iClient > 0 && iClient <= MaxClients && IsClientInGame(iClient) && VIP_IsClientVIP(iClient))
	{
		new bool:bStatus = bool:GetNativeCell(2);

		// native int VIP_FillArrayByFeatures(ArrayList hArray);

		if(bStatus)
		{
			if(!g_hFeatures[iClient])
			{
				return;
			}

			new iSize = GetArraySize(hFeaturesArray);
			if(iSize)
			{
				decl i, String:szFeature[64], VIP_ToggleState:eToggleState;
				for(i = 0; i < iSize; ++i)
				{
					GetArrayString(hFeaturesArray, i, szFeature, sizeof(szFeature));
					if(VIP_IsValidFeature(szFeature))
					{
						if (GetTrieValue(g_hFeatures[iClient], szFeature, eToggleState))
						{
							VIP_SetClientFeatureStatus(iClient, szFeature, eToggleState);
						}
					}
				}
			}

			CloseHandle(g_hFeatures[iClient]);
			g_hFeatures[iClient] = INVALID_HANDLE;
		}
		else
		{
			if(g_hFeatures[iClient])
			{
				return;
			}

			new iSize = GetArraySize(hFeaturesArray);
			if(iSize)
			{	
				g_hFeatures[iClient] = CreateTrie();

				decl i, String:szFeature[64], VIP_ToggleState:eToggleState;
				for(i = 0; i < iSize; ++i)
				{
					GetArrayString(hFeaturesArray, i, szFeature, sizeof(szFeature));
					if(VIP_IsValidFeature(szFeature))
					{
						eToggleState = VIP_GetClientFeatureStatus(iClient, szFeature);
						if (eToggleState != NO_ACCESS)
						{
							SetTrieValue(g_hFeatures[iClient], szFeature, eToggleState);
							VIP_SetClientFeatureStatus(iClient, szFeature, NO_ACCESS);
						}
					}
				}
			}
		}
	}

	return 0;
}
*/

public Native_ToggleFeatures(Handle:hPlugin, iNumParams)
{
	new iClient = GetNativeCell(1);
	if(iClient > 0 && iClient <= MaxClients && IsClientInGame(iClient) && VIP_IsClientVIP(iClient))
	{
	//	LogMessage("Native_ToggleFeatures: %N (%d)", iClient, iClient);
		new Handle:hFeaturesArray = Handle:GetNativeCell(3);
		if(!hFeaturesArray)
		{
			return 0;
		}

		new bool:bStatus = bool:GetNativeCell(2);
	//	LogMessage("bStatus = %b", bStatus);
	//	LogMessage("g_hFeatures = %x", g_hFeatures[iClient]);
		
		if(bStatus)
		{
			if(!g_hFeatures[iClient] || !GetTrieSize(g_hFeatures[iClient]))
			{
				return 0;
			}

			new iSize = GetArraySize(hFeaturesArray);
		//	LogMessage("iSize = %d", iSize);
			if(iSize)
			{
				decl i, String:szFeature[64], VIP_ToggleState:eToggleState;
				for(i = 0; i < iSize; ++i)
				{
					GetArrayString(hFeaturesArray, i, szFeature, sizeof(szFeature));
				//	LogMessage("szFeature = '%s'", szFeature);
					if(VIP_IsValidFeature(szFeature))
					{
						if (GetTrieValue(g_hFeatures[iClient], szFeature, eToggleState))
						{
						//	LogMessage("eToggleState = %d", eToggleState);
							VIP_SetClientFeatureStatus(iClient, szFeature, eToggleState);
							RemoveFromTrie(g_hFeatures[iClient], szFeature);
						}
					}
				}
			}

			if(!GetTrieSize(g_hFeatures[iClient]))
			{
				CloseHandle(g_hFeatures[iClient]);
				g_hFeatures[iClient] = INVALID_HANDLE;
			}
			return 0;
		}
		
		new iSize = GetArraySize(hFeaturesArray);
	//	LogMessage("iSize = %d", iSize);
		if(iSize)
		{
			if(!g_hFeatures[iClient])
			{
				g_hFeatures[iClient] = CreateTrie();
			}

			decl i, String:szFeature[64], VIP_ToggleState:eToggleState;
			for(i = 0; i < iSize; ++i)
			{
				GetArrayString(hFeaturesArray, i, szFeature, sizeof(szFeature));
			//	LogMessage("szFeature = '%s'", szFeature);
				if(VIP_IsValidFeature(szFeature))
				{
					eToggleState = VIP_GetClientFeatureStatus(iClient, szFeature);
				//	LogMessage("eToggleState = %d", eToggleState);
					if (eToggleState != NO_ACCESS)
					{
						SetTrieValue(g_hFeatures[iClient], szFeature, eToggleState);
						VIP_SetClientFeatureStatus(iClient, szFeature, NO_ACCESS);
					}
				}
			}
		}
	}

	return 0;
}

public Native_ToggleFeature(Handle:hPlugin, iNumParams)
{
	new iClient = GetNativeCell(1);
	if(iClient > 0 && iClient <= MaxClients && IsClientInGame(iClient) && VIP_IsClientVIP(iClient))
	{
		decl String:szFeature[64];
		GetNativeString(3, szFeature, sizeof(szFeature));
		if(!VIP_IsValidFeature(szFeature))
		{
			return 0;
		}

		new bool:bStatus = bool:GetNativeCell(2);
		
		if(bStatus)
		{
			if(!g_hFeatures[iClient])
			{
				return 0;
			}

			decl VIP_ToggleState:eToggleState;
			if (GetTrieValue(g_hFeatures[iClient], szFeature, eToggleState))
			{
				VIP_SetClientFeatureStatus(iClient, szFeature, eToggleState);
				RemoveFromTrie(g_hFeatures[iClient], szFeature);
			}

			/*CloseHandle(g_hFeatures[iClient]);
			g_hFeatures[iClient] = INVALID_HANDLE;*/
		}
		else
		{

			new VIP_ToggleState:eToggleState = VIP_GetClientFeatureStatus(iClient, szFeature);
			if (eToggleState != NO_ACCESS)
			{
				if(!g_hFeatures[iClient])
				{
					g_hFeatures[iClient] = CreateTrie();
				}
				SetTrieValue(g_hFeatures[iClient], szFeature, eToggleState);
				VIP_SetClientFeatureStatus(iClient, szFeature, NO_ACCESS);
			}
		}
	}

	return 0;
}

public OnMapStart()
{
//	LoadConfigs();

	g_iRounds = 0;

	if(g_bIsCSGO)
	{
		new Handle:hCvar = FindConVar("mp_warmuptime");
		if(hCvar != INVALID_HANDLE)
		{
			new Float:fDuration = GetConVarFloat(hCvar);
			if(fDuration > 0.0)
			{
				g_iRounds = -1;
				CreateTimer(fDuration, Timer_ResetRound, _, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}

public Action:Timer_ResetRound(Handle:hTimer)
{
	g_iRounds = 0;
	return Plugin_Stop;
}

public Event_RoundEnd(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{
	if(g_iRounds == -1)
	{
		return;
	}
	
	decl String:sReason[64];
	GetEventString(hEvent, "message", sReason, sizeof(sReason));
	if(strcmp(sReason, "#Game_Commencing") == 0)
	{
		g_iRounds = 0;
	}
}

public Event_Restart(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{
	g_iRounds = 0;
}

public Event_RoundStart(Handle:hEvent, const String:name[], bool:dontBroadcast)
{
	if(g_iRounds == -1)
	{
		return;
	}

	g_iRounds++;
}

public OnClientDisconnect(iClient)
{
	ResetClient(iClient);
}

public VIP_OnVIPClientRemoved(iClient, const String:sReason[])
{
	ResetClient(iClient);
}

ResetClient(iClient)
{
	if(g_hFeatures[iClient])
	{
		CloseHandle(g_hFeatures[iClient]);
		g_hFeatures[iClient] = INVALID_HANDLE;
	}
}

public VIP_OnVIPClientLoaded(iClient)
{
//	g_hFeatures[iClient] = CreateTrie();
	
	/*new iSize = GetArraySize(g_hFeaturesArray);
	if(iSize)
	{
		decl Handle:hFeatureSettings, i, String:szFeature[64];
		for(i = 0; i < iSize; ++i)
		{
			GetArrayString(g_hFeaturesArray, i, szFeature, sizeof(szFeature));
			SetTrieValue(g_hFeatures[iClient], szFeature, VIP_GetClientFeatureStatus(iClient, szFeature));
			
			GetTrieValue(g_hFeaturesTrie, szFeature, hFeatureSettings);
			if(GetArrayCell(hFeatureSettings, FS_CurrentStatus) == 0)
			{
				VIP_SetClientFeatureStatus(iClient, szFeature, NO_ACCESS);
	//			PrintToChat(iClient, "Отключено: %s", szFeature);
			}
		}
	}*/
}